/* File: rs_dist_codes.c
 * 
 * Hatem Nassrat
 * B00393388 - Dalhousie University
 *
 * A Fault tolerance Implementation for an OLAP system
 *
 */

#include <mpi.h>
#include <stdio.h>
#include <strings.h>
#include <sys/time.h>

#define IC_CREATE_TAG 5

int main(int argc, char * argv[])
{
    int i,j, my_rank, p, f;
    char buf[BUFSIZ];
    MPI_Comm *my_comm;
    FILE *file;
    char **nodes,*temp;
    struct timeval start,stop;

    /*MPI INIT*/
    
    MPI_Init(&argc,&argv);
    MPI_Comm_rank(MPI_COMM_WORLD,&my_rank);
    MPI_Comm_size(MPI_COMM_WORLD, &p);
    f=p;

    /*END OF: MPI INIT*/

    //printf("P%d: here",my_rank);
    //exit(0);

    gettimeofday(&start,NULL);
    
    file = fopen("hostfile","r");
    nodes = malloc(p*sizeof(char*));
    for(i=0;i<p;i++)
    {
        fgets(buf,BUFSIZ,file);
        buf[strlen(buf)-1]=0;
        nodes[i]=strdup(buf);
    }
    fclose(file);
    
    if(my_rank != 0)
    {
        for(i=0,j=1;i<p-2;i++,j++)
        {
            if(j==my_rank)j++;
            //sprintf(buf, "scp /tmp/pcc05/P%d-%04d.rs %s:/tmp/pcc05/P%d-%04d.rs", my_rank, i, nodes[j], my_rank, i);
            //system("scp ");
            sprintf(buf,"scp /tmp/pcc05/P%d-%04d.rs %s:/tmp/pcc05/P%d-%04d.rs", my_rank, i, nodes[j], my_rank, i);
            //printf("%s\n",buf);
            system(buf);
            sprintf(buf,"rm /tmp/pcc05/P%d-%04d.rs", my_rank, i);
            //printf("%s\n",buf);
            system(buf);
        }
        sprintf(buf, "scp /tmp/pcc05/P%d-info.txt %s:/tmp/pcc05/P%d-info.txt", my_rank, nodes[0], my_rank);
        system(buf);
        sprintf(buf, "rm /tmp/pcc05/P%d-info.txt",my_rank);
        system(buf);
    }

    gettimeofday(&stop,NULL);
    if(my_rank==1)
        printf("Time to dist rs-codes = %.4f\n",
                (stop.tv_sec-start.tv_sec)+
                ((float)(stop.tv_usec-start.tv_usec))/(1000000));
   
   /* Finalize */
    //if(my_rank==0) 
    //    for (i=1; i<p; i++) MPI_Comm_free(&my_comm[i-1]);
    //else MPI_Comm_free(my_comm);
    MPI_Finalize();
    exit(0);
}
