/* File: MPI_Fault.c
 * 
 * Hatem Nassrat
 * B00393388 - Dalhousie University
 *
 * A Fault tolerance Implementation for an OLAP system
 *
 */

#include <mpi.h>
#include <stdio.h>
#include <strings.h>
#include <sys/time.h>

#define IC_CREATE_TAG 5

int main(int argc, char * argv[])
{
    int i,j, my_rank, p, flag;
    char buf[BUFSIZ];
    MPI_Comm *my_comm;
    FILE *file;
    char *node0,*temp;
    struct timeval start,stop;

    /*MPI INIT*/
    
    MPI_Init(&argc,&argv);
    MPI_Comm_rank(MPI_COMM_WORLD,&my_rank);
    MPI_Comm_size(MPI_COMM_WORLD, &p);

    for(i=1;i<argc;i++)
    {
        if(my_rank == atoi(argv[i])) exit(0);
    }
    /*END OF: MPI INIT*/

    gettimeofday(&start,NULL);
    //printf("P%d: here",my_rank);
    //exit(0);
    
    file = fopen("hostfile","r");
    fgets(buf,BUFSIZ,file);
    buf[strlen(buf)-1]=0;
    node0=strdup(buf);
    fclose(file);
    
    
    if(my_rank != 0)
    {
        for(i=1;i<argc;i++)
        {
            sprintf(buf,"scp /tmp/pcc05/P%d-*.rs %s:/tmp/pcc05/", atoi(argv[i]), node0, atoi(argv[i]));
            //printf("P%d: %s\n",my_rank,buf);
            system(buf);
        }
    }

    gettimeofday(&stop,NULL);
    if(my_rank==1)
        printf("Gather RS-codes: time= %.4f\n",
                (stop.tv_sec-start.tv_sec)+
                ((float)(stop.tv_usec-start.tv_usec))/(1000000));
   
    MPI_Finalize();
    exit(0);
}
